# emacs-mode: -*- python-*-
__version__ = '0.2'
from Globals import HTML, HTMLFile, MessageDialog
from ImageFile import ImageFile
import Globals
import sys
import traceback
from OFS.DTMLDocument import DTMLDocument
from AccessControl import getSecurityManager
from OFS.PropertyManager import PropertyManager
import urllib
import socket
import httplib
import os
import stat
import string
import posixfile
import sys
import traceback
from xml.xslt.Processor import Processor

manage_addZopeXmlPipeform = HTMLFile('dtml/addZopeXmlPipeform', globals())

def manage_addZopeXmlPipe(self, id = '', title = '', server = '', web_path = '', port = '', style = '', cacheon = 0, cachetime = 0, REQUEST = None, submit = None):
    """Add a Zope Xml Pipe Document """
    if (id == ''):
        return MessageDialog(title='Error', message='Please enter an id!', action=(REQUEST['URL1'] + '/add_doc_form'))
    id = str(id)
    ob = ZopeXmlPipe(default='', __name__=id)
    ob.port = port
    ob.web_path = web_path
    ob.server = server
    ob.style = style
    try:
        cacheon = int(cacheon)
    except:
        cacheon = 0
    try:
        cachetime = int(cachetime)
    except:
        cachetime = 0
    ob.cacheon = cacheon
    ob.cachetime = cachetime
    id = self._setObject(id, ob)
    if (REQUEST is not None):
        try:
            u = self.DestinationURL()
        except:
            u = REQUEST['URL1']
        if (submit == 'Add'):
            u = ('%s/%s' % (u,
             quote(id)))
        REQUEST.RESPONSE.redirect((u + '/manage_main'))
    return 'Nothing'


class ZopeXmlPipe(PropertyManager, DTMLDocument):
    """ Zope Product object."""
    meta_type = 'Zope Xml Pipe'
    icon = 'misc_/ZopeXmlPipe/docicon'
    
    manage_options = ({'label':'Edit','action':'manage_page'},{'label':'View','action':'__call__'},)+DTMLDocument.manage_options

    manage_page = HTMLFile('dtml/editZopeXmlPipeform', globals())

    _properties = ( {'id':'server','type':'string'},)

    def __call__(self, client = None, REQUEST = {}, RESPONSE = None, **kw):
        """  """
        bself = self.aq_explicit
        r = apply(HTML.__call__, (self, bself, REQUEST), kw)

        try:
            h = httplib.HTTP(('%s:%s' % (self.server,
             self.port)))
            QUERY_STRING = urllib.urlencode(REQUEST.form)
            h.putrequest('GET', ('%s?%s' % (self.web_path,
             QUERY_STRING)))
            h.putheader('Accept', 'text/html')
            h.putheader('Accept', 'text/plain')
            h.endheaders()
            (errcode, errmsg, headers,) = h.getreply()
            f = h.getfile()
            data = f.read()
            f.close()
        except:
            (type, val, tb,) = sys.exc_info()
            data = ('\n<html>\n<body bgcolor="eeeeff">\n<font color="red">\nAn error occured!<br>\nTo fix problem:\n</font>\n<hr>\n<pre>\n%s\n</pre>\n</body>\n</html>\n' % (string.join(traceback.format_exception(type, val, tb), '')))
            del type
            del val
            del tb
        try:
            res = self.standard_html_header(self, REQUEST)
            objet = getattr(self, self.style, None)
            xsl = objet.__call__(client=self, REQUEST=REQUEST, RESPONSE=RESPONSE, kw=kw)
            xsltproc = Processor()
            xsltproc.appendStylesheetString(xsl)
            res = (res + xsltproc.runString(data))
            data = (res + self.standard_html_footer(self, REQUEST))
        except:
            data = ('\n<html>\n<body bgcolor="eeeeff">\n<font color="red">\nAn error occured!<br>\nTo fix problem:\n</font>\n<hr>\n<pre>\n%s %s\n</pre>\n</body>\n</html>\n' % (string.join(traceback.format_exception(type, val, tb), ''))),
        RESPONSE.setHeader('content-type', 'text/html')
        return data 


    def manage_edit(self, id = '', title = '', server = '', web_path = '', port = '', style = '', cacheon = 0, cachetime = 0, REQUEST = None, submit = None):
	"""
	"""
	self.port = port
	self.web_path = web_path
	self.server = server
	self.style = style
        REQUEST.RESPONSE.redirect(( self.absolute_url() + '/manage_main'))	

Globals.default__class_init__(ZopeXmlPipe)

# local variables:
# tab-width: 4
